/**
@author Devyn Collier Johnson <DevynCJohnson@Gmail.com>
@copyright LGPLv3

@brief Standard Header Macros
@version 2016.01.01

@section LICENSE
GNU Lesser General Public License v3
Copyright (c) Devyn Collier Johnson, All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 3.0 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.
*/


#ifndef _ISOC11_SOURCE  // C11
#   define _ISOC11_SOURCE
#endif
#ifndef __STDC_VERSION__  // C11
#   define __STDC_VERSION__ 201112L
#endif
#ifdef __linux__  // Linux
#   include <unistd.h>
#   ifndef _GNU_SOURCE
#      define _GNU_SOURCE
#   endif
#elif defined(_WIN32) || defined(_WIN64)  // Windows
#   include <windows.h>
#elif defined(__unix__) || defined(__unix) || (defined(__APPLE__) && defined(__MACH__))  // Unix-systems
#   define _POSIX_C_SOURCE 200809L
#   define _XOPEN_SOURCE 700
#   include <sys/param.h>
#   include <unistd.h>
#endif
#ifdef BSD  // BSD
#   undef _GNU_SOURCE
#   undef _POSIX_C_SOURCE
#   define _BSD_SOURCE
#   define _XOPEN_SOURCE 700
#endif
// 64-bit or 32-bit? "#if defined(ENV64BIT)"
#if defined(_WIN64) || defined(__x86_64__) || defined(__ppc64__)
#   ifndef ENV64BIT
#      define ENV64BIT
#   endif
#else
#   ifndef ENV32BIT
#      define ENV32BIT
#   endif
#endif
