/**
@author Devyn Collier Johnson <DevynCJohnson@Gmail.com>
@copyright LGPLv3

@brief Fibonacci Number Generator
@version 2016.01.01
@usage ./fib 10  # Return the tenth Fibonacci number

@section LICENSE
GNU Lesser General Public License v3
Copyright (c) Devyn Collier Johnson, All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 3.0 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.
*/

// gcc -Wall -Wextra -pedantic -O3 -Wl,-O3 -g0 -ggdb0 -s -fwhole-program -funroll-loops -pthread -pipe -ffunction-sections -fdata-sections -std=c11 -o ./fib ./fib.c && strip --remove-section=.note --remove-section=.comment --strip-debug --strip-unneeded ./fib
// gcc -march=haswell -Wall -Wextra -pedantic -ffast-math -O3 -Wl,-O3 -g0 -ggdb0 -s -fwhole-program -funroll-loops -pthread -pipe -ffunction-sections -fdata-sections -std=c11 ./fib.c -o ./fib && strip --remove-section=.note --remove-section=.comment --strip-debug --strip-unneeded ./fib


#include <stdio.h>
#include <stdlib.h>

#include "MACROS.h"


unsigned long int fib(const unsigned int num);


unsigned long int fib(const unsigned int num) {
    // Fibonacci Number Generator
    unsigned int i;
    unsigned long int fval[num+1];
    if (num > (unsigned int) 410) {
        fprintf(stderr, "ERROR! Number too large.\n");
        return (unsigned long int) 1;
    } else {
        if (num == (unsigned int) 0) {
            return (unsigned long int) 0;
        } else if (num == (unsigned int) 1 || num == (unsigned int) 2) {
            return (unsigned long int) 1;
        } else {
            fval[0] = (unsigned long int) 0;
            fval[1] = (unsigned long int) 1;
            fval[2] = (unsigned long int) 1;
            fval[3] = (unsigned long int) 2;
            fval[4] = (unsigned long int) 3;
            for (i = (unsigned int) 2; i <= num; i++)
                fval[i] = fval[i - 1] + fval[i - 2];
            return fval[num];
        }
    }
}


int main(int argc, char *argv[]) {
    if (argc != 2) {
        fprintf(stderr, "Expected 1 parameter, but was given %d\n", argc - 1);
        return 1;
    }
    printf("%lu\n", fib((unsigned int) strtol(argv[1], (char **)NULL, 10)));
    return 0;
}
