/**
@author Devyn Collier Johnson <DevynCJohnson@Gmail.com>
@copyright LGPLv3

@brief getpgid() - returns the Process Group ID
@version 2016.01.01

@section LICENSE
GNU Lesser General Public License v3
Copyright (c) Devyn Collier Johnson, All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 3.0 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.
*/

// gcc -Wall -Wextra -pedantic -O3 -Wl,-O3 -g0 -ggdb0 -s -fwhole-program -funroll-loops -pthread -pipe -ffunction-sections -fdata-sections -std=gnu11 -o ./getpgid ./getpgid.c && strip --remove-section=.note --remove-section=.comment --strip-debug --strip-unneeded ./getpgid


#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/types.h>


int main(int argc, char *argv[]) {
    int pid, pgid;
    if (argc != 2) {
        fprintf(stderr, "Expected one parameter, but was given %d\n", argc - 1);
        return 1;
    } else {
        pid = (int) strtol(argv[1], (char **)NULL, 10);
    }
    pgid = getpgid(pid);
    printf("%d\n", pgid);
    return 0;
}
