/**
@author Devyn Collier Johnson <DevynCJohnson@Gmail.com>
@copyright LGPLv3

@brief Print the size of each datatype
@version 2016.01.01

@section LICENSE
GNU Lesser General Public License v3
Copyright (c) Devyn Collier Johnson, All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 3.0 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.
*/

// gcc -Wall -Wextra -pedantic -O3 -Wl,-O3 -g0 -ggdb0 -s -fwhole-program -funroll-loops -pthread -pipe -ffunction-sections -fdata-sections -std=c11 -o ./typesize ./typesize.c && strip --remove-section=.note --remove-section=.comment --strip-debug --strip-unneeded ./typesize


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include "MACROS.h"


int main(void) {
    // Get Datatype Size
    const unsigned long charsize = (unsigned long)sizeof(char);
    const unsigned long signedcharsize = (unsigned long)sizeof(signed char);
    const unsigned long unsignedcharsize = (unsigned long)sizeof(unsigned char);
    const unsigned long intsize = (unsigned long)sizeof(int);
    const unsigned long signedsize = (unsigned long)sizeof(signed);
    const unsigned long signedintsize = (unsigned long)sizeof(signed int);
    const unsigned long unsignedsize = (unsigned long)sizeof(unsigned);
    const unsigned long unsignedintsize = (unsigned long)sizeof(unsigned int);
    const unsigned long shortsize = (unsigned long)sizeof(short);
    const unsigned long shortintsize = (unsigned long)sizeof(short int);
    const unsigned long signedshortsize = (unsigned long)sizeof(signed short);
    const unsigned long signedshortintsize = (unsigned long)sizeof(signed short int);
    const unsigned long unsignedshortsize = (unsigned long)sizeof(unsigned short);
    const unsigned long unsignedshortintsize = (unsigned long)sizeof(unsigned short int);
    const unsigned long longsize = (unsigned long)sizeof(long);
    const unsigned long longintsize = (unsigned long)sizeof(long int);
    const unsigned long signedlongsize = (unsigned long)sizeof(signed long);
    const unsigned long signedlongintsize = (unsigned long)sizeof(signed long int);
    const unsigned long unsignedlongsize = (unsigned long)sizeof(unsigned long);
    const unsigned long unsignedlongintsize = (unsigned long)sizeof(unsigned long int);
    const unsigned long longlongsize = (unsigned long)sizeof(long long);
    const unsigned long longlongintsize = (unsigned long)sizeof(long long int);
    const unsigned long signedlonglongsize = (unsigned long)sizeof(signed long long);
    const unsigned long signedlonglongintsize = (unsigned long)sizeof(signed long long int);
    const unsigned long unsignedlonglongsize = (unsigned long)sizeof(unsigned long long);
    const unsigned long unsignedlonglongintsize = (unsigned long)sizeof(unsigned long long int);
    const unsigned long floatsize = (unsigned long)sizeof(float);
    const unsigned long doublesize = (unsigned long)sizeof(double);
    const unsigned long longdoublesize = (unsigned long)sizeof(long double);
    const unsigned long floatcomplexsize = (unsigned long)sizeof(float _Complex);
    const unsigned long doublecomplexsize = (unsigned long)sizeof(double _Complex);
    const unsigned long longdoublecomplexsize = (unsigned long)sizeof(long double _Complex);
    const unsigned long boolsize = (unsigned long)sizeof(_Bool);
    const unsigned long sizetsize = (unsigned long)sizeof(size_t);
    #if defined(_POSIX_VERSION)
    const unsigned long ssizetsize = (unsigned long)sizeof(ssize_t);
    #endif
    const unsigned long ptrsize = (unsigned long)sizeof(char*);
    const unsigned long adrsize = (unsigned long)sizeof(&ptrsize);
    // Display Sizes
    printf("Char: %lu\n", charsize);
    printf("Signed Char: %lu\n", signedcharsize);
    printf("Unsigned Char: %lu\n", unsignedcharsize);
    printf("Int: %lu\n", intsize);
    printf("Signed: %lu\n", signedsize);
    printf("Signed Int: %lu\n", signedintsize);
    printf("Unsigned: %lu\n", unsignedsize);
    printf("Unsigned Int: %lu\n", unsignedintsize);
    printf("Short: %lu\n", shortsize);
    printf("Short Int: %lu\n", shortintsize);
    printf("Signed Short: %lu\n", signedshortsize);
    printf("Signed Short Int: %lu\n", signedshortintsize);
    printf("Unsigned Short: %lu\n", unsignedshortsize);
    printf("Unsigned Short Int: %lu\n", unsignedshortintsize);
    printf("Long: %lu\n", longsize);
    printf("Long Int: %lu\n", longintsize);
    printf("Signed Long: %lu\n", signedlongsize);
    printf("Signed Long Int: %lu\n", signedlongintsize);
    printf("Unsigned Long: %lu\n", unsignedlongsize);
    printf("Unsigned Long Int: %lu\n", unsignedlongintsize);
    printf("Long Long: %lu\n", longlongsize);
    printf("Long Long Int: %lu\n", longlongintsize);
    printf("Signed Long Long: %lu\n", signedlonglongsize);
    printf("Signed Long Long Int: %lu\n", signedlonglongintsize);
    printf("Unsigned Long Long: %lu\n", unsignedlonglongsize);
    printf("Unsigned Long Long Int: %lu\n", unsignedlonglongintsize);
    printf("Float: %lu\n", floatsize);
    printf("Double: %lu\n", doublesize);
    printf("Long Double: %lu\n", longdoublesize);
    printf("Float Complex: %lu\n", floatcomplexsize);
    printf("Double Complex: %lu\n", doublecomplexsize);
    printf("Long Double Complex: %lu\n", longdoublecomplexsize);
    printf("_Bool: %lu\n", boolsize);
    printf("size_t: %lu\n", sizetsize);
    #if defined(_POSIX_VERSION)
    printf("ssize_t: %lu\n", ssizetsize);
    #endif
    printf("Char*: %lu\n", ptrsize);
    printf("&adrsize: %lu\n", adrsize);
    return 0;
}
